#include <msp430.h>
#include <stdint.h>
#include <stdio.h>
#include "dr_i2c.h"
#include "dr_tft.h"
#include <math.h>

#define ADXL345_ADDR_w 0xA6
#define ADXL345_ADDR_r 0xA7
#define OFSX 0x1E
#define OFSY 0x1F
#define OFSZ 0x20
#define THRESH_ACT 0x24
#define THRESH_INACT 0x25
#define DATAX0 0x32
#define DATAX1 0x33
#define DATAY0 0x34
#define DATAY1 0x35
#define DATAZ0 0x36
#define DATAZ1 0x37
#define DATA_FORMAT  0x31
#define BW_RATE      0x2C
#define POWER_CTL    0x2D
#define INT_ENABLE   0x2E



int ADXL345_ADDR_INDEX;
int OFSX_INDEX;
int OFSY_INDEX;
int OFSZ_INDEX;
int THRESH_ACT_INDEX;
int THRESH_INACT_INDEX;
int DATAX0_INDEX;
int DATAX1_INDEX;
int DATAY0_INDEX;
int DATAY1_INDEX;
int DATAZ0_INDEX;
int DATAZ1_INDEX;




//ʱӳʼ
void initClock()
{
  while(BAKCTL & LOCKIO) // Unlock XT1 pins for operation
    BAKCTL &= ~(LOCKIO);
  UCSCTL6 &= ~XT1OFF; //XT1
  P7SEL |= BIT2 + BIT3; //XT2Źѡ
  UCSCTL6 &= ~XT2OFF; //XT2
  while (SFRIFG1 & OFIFG) { //ȴXT1XT2DCOȶ
    UCSCTL7 &= ~(DCOFFG+XT1LFOFFG+XT2OFFG);
    SFRIFG1 &= ~OFIFG;
  }

  UCSCTL4 = SELA__XT1CLK + SELS__XT2CLK + SELM__XT2CLK; //DCOܷ

  UCSCTL1 = DCORSEL_5; //6000kHz~23.7MHz
  UCSCTL2 = 20000000 / (4000000 / 16); //XT2ƵʽϸߣƵΪ׼ɻøߵľ
  UCSCTL3 = SELREF__XT2CLK + FLLREFDIV__16; //XT216ƵΪ׼
  while (SFRIFG1 & OFIFG) { //ȴXT1XT2DCOȶ
    UCSCTL7 &= ~(DCOFFG+XT1LFOFFG+XT2OFFG);
    SFRIFG1 &= ~OFIFG;
  }
  UCSCTL5 = DIVA__1 + DIVS__1 + DIVM__1; //趨CLKķƵ
  UCSCTL4 = SELA__XT1CLK + SELS__DCOCLK + SELM__DCOCLK; //趨CLKʱԴ
}
int wan,qian,bai,shi,ge;
void conversion(int temp_data)  
{  
	
    wan=temp_data/10000+0x30 ;
    temp_data=temp_data%10000;   //ȡ
	qian=temp_data/1000+0x30 ;
    temp_data=temp_data%1000;    //ȡ
    bai=temp_data/100+0x30   ;
    temp_data=temp_data%100;     //ȡ
    shi=temp_data/10+0x30    ;
    temp_data=temp_data%10;      //ȡ
    ge=temp_data+0x30; 	
}


int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;//رտŹ

  _DINT();//ж

  initClock();//ʼʱ
  initI2C();//ʼڲЭ
  
  //ʼADXL345
   I2C_RequestSend(ADXL345_ADDR_w,DATA_FORMAT,0x0B);
   I2C_RequestSend(ADXL345_ADDR_w,BW_RATE,0x08);
   I2C_RequestSend(ADXL345_ADDR_w,POWER_CTL,0x08);
   I2C_RequestSend(ADXL345_ADDR_w,INT_ENABLE,0x00);
   I2C_RequestSend(ADXL345_ADDR_w,OFSX,0x00);
   I2C_RequestSend(ADXL345_ADDR_w,OFSY,0x00);
   I2C_RequestSend(ADXL345_ADDR_w,OFSZ,0x05);
   
  initTFT();//ʼTFT
  //ѯǷȡ
  THRESH_ACT_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r,THRESH_ACT );
  THRESH_INACT_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r,THRESH_INACT );
  DATAX0_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAX0);
  DATAX1_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAX1);
  DATAY0_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAY0);
  DATAY1_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAY1);
  DATAZ0_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAZ0);
  DATAZ1_INDEX = I2C_AddRegQuery(ADXL345_ADDR_r, DATAZ1);

  _EINT();//رжϡ
  float s,a;
  int b1,b2,b3;
  etft_AreaSet(0,0,319,239,0);
  while(1)
  {
    int a1,a2,a3;
	float a;
    char buffer[41];
    if(I2C_QueryHasNew(DATAX1_INDEX))
    {
      //if(I2C_QueryHasNew(DATAX0_INDEX)
	  a1 = I2C_CheckQuery(DATAX1_INDEX);
	  a2 = I2C_CheckQuery(DATAX0_INDEX);
      a3=(a1<<8)+a2;
	  if(a3<0)
	  {
	  etft_DisplayString('-' ,16, 0, 0xFFFF, 0x0000);
	  a3=-a3;
	  }
	  a=(float)a3*3.9;
	  b1=a;
	  conversion(a);
      static int count;
      sprintf(buffer, "ax%d=%d.%d%dg",count++ & 0x07, qian, bai,shi);
      etft_DisplayString(buffer, 32, 0, 0xFFFF, 0x0000);
    }
	if(I2C_QueryHasNew(DATAY1_INDEX))
    {
	  //if(I2C_QueryHasNew(DATAY0_INDEX)
	  a1 = I2C_CheckQuery(DATAY1_INDEX);
	  a2 = I2C_CheckQuery(DATAY0_INDEX);
      a3=(a1<<8)+a2;
	  if(a3<0)
	  a3=-a3;
	  a=(float)a3*3.9;
	  b2=a;
	  conversion(a);
      static int count;
      sprintf(buffer, "ax%d =%d.%d%dg", count++ & 0x07, qian, bai,shi);
      etft_DisplayString(buffer, 0, 16, 0xFFFF, 0x0000);
    }
	if(I2C_QueryHasNew(DATAZ1_INDEX))
    {
	  //if(I2C_QueryHasNew(DATAZ0_INDEX)
	  a1 = I2C_CheckQuery(DATAZ1_INDEX);
	  a2 = I2C_CheckQuery(DATAZ0_INDEX);
      a3=(a1<<8);
	  if(a3<0)
	  a3=-a3;
	  a=(float)a3*3.9;
	  b3=a;
	  conversion(a);
      static int count;
      sprintf(buffer, "ax%d =%d.%d%dg", count++ & 0x07, qian, bai,shi);
      etft_DisplayString(buffer, 0, 32, 0xFFFF, 0x0000);
    }
	s=sqrt(b1*b1+b2*b2+b3*b3);
	char buf2[40];
	if(0.9<s&&s<1.2)
	{
	sprintf(buf2, "վ״̬");
    etft_DisplayString(buf2, 0, 64, 0xFFFF, 0x0000);
	}
	else if(1.5<s&&s<2.5)
	{
    sprintf(buf2, "״̬");
    etft_DisplayString(buf2, 0, 128, 0xFFFF, 0x0000);
	}
	else if(2.5<s&&s<7)
	{
	sprintf(buf2, "ܲ״̬");
    etft_DisplayString(buf2, 0, 156, 0xFFFF, 0x0000);
	}
    __delay_cycles(2000000);
  }
}
